#!/usr/bin/python
# -*- coding: iso8859-1 -*

#!/usr/bin/python
############################################################################
#    Copyright (C) 2006 by Cesar Kallas   	
#    cesarkallas[a]soulivre.org     - http://cesarkallas.soulivre.org
#                                                                          
#    This program is free software; you can redistribute it and#or modify  
#    it under the terms of the GNU General Public License as published by  
#    the Free Software Foundation; either version 2 of the License, or     
#    (at your option) any later version.                                   
#                                                                          
#    This program is distributed in the hope that it will be useful,       
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
#    GNU General Public License for more details.                          
#                                                                          
#    You should have received a copy of the GNU General Public License     
#    along with this program; if not, write to the                         
#    Free Software Foundation, Inc.,                                       
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             
############################################################################
#	2. Projeto - Uma Aplicacao Distribuida
#	Pontificia Universidade Catolica de Campinas		-	 PUC Campinas
#	Sistemas Distribuidos	-	Prof Eduardo Zagari	-	http://docentes.puc-campinas.edu.br/ceatec/zagari/
#	Aluno: Cesar Kallas	-	RA: 02099224			-	Engenharia de Computacao

import socket
import sys
import time
import math
import string
import thread

def InversaoFrase(frase):
	"""
	Funcao que inverte uma frase
	Entradas:
		frase: string
	Saida:
		fraseInvertida: string com a frase de entrada invertida
		-1: para falha
	"""
	try:
		fraseInvertida = frase[::-1]
		return fraseInvertida
	except Exception:
		return "-1"


def RaizQuadrada(numero):
	"""
	Funcao que calcula a raiz quadrada de um numero
	Entrada:
		numero: numero a ser calculado a raiz quadrada
	Saida:
		raiz: raiz quadrada do numero
		-1: para falha
	"""
	try:
		raiz = math.sqrt(float(numero))
		return raiz
	except Exception:
		return "-1"


def MaximoDivisor(numero):
	"""
	Funcao que calcula o maximo divisor de um numero
	Entrada:
		numero: numero para ser calcula o seu maximo divisor
	Saida:
		maxDiv: maximo divisor do numero
		-1: para falha
	"""
	try:
		numero = int(numero)
		if numero <= 1:
				return numero
		maxDiv = numero

		for i in range(1, numero-1):
				if numero % (i) == 0:
						maxDiv = i

		if maxDiv == 1:
				if numero > 1:
						return numero
		return maxDiv
	except Exception:
		return "-1"



def trataCliente(skt_cliente, skt_cliente_endereco):
	"""
	Thread que trata o pedido do cliente
	Entradas:
		skt_cliente: tipo socket, com a conexao tcp estabelecida
		skt_cliente_endereco: estrutura com endereco do cliente
	Saidas:
		impressoes na tela sobre o pedido do cliente
		respostas aos clientes conectados, via o socket
	"""
	recebe = 1
	frase = ""
	numero = ""
	
	while recebe:
		try:
			msg = string.lower(skt_cliente.recv(100*1024))
			print "---\nDe %s:%s\nMsg: '%s'" % (skt_cliente_endereco[0], skt_cliente_endereco[1], msg)

			if msg[0:4] == "quit":
				online = 0
				print "Cliente desconectado.\n---"
				break
			
			elif msg[0:6] == "opcoes":
				resposta = "Opcoes:\n\tInversaoFrase(frase)\n\tRaizQuadrada(numero)\n\tMaximoDivisor(numero)\n\tQuit"
			
			elif len(msg) < 12:
				resposta = "opcao invalida"
			
			elif msg[0:13] == "inversaofrase":
				frase = msg[msg.rfind("(")+1:msg.rfind(")")]
				print "InversaoFrase: '%s'" % frase
				resposta = InversaoFrase(frase)
					
			elif msg[0:12] == "raizquadrada" :
				numero = msg[msg.rfind("(")+1:msg.rfind(")")]
				print "RaizQuadrada: '%s'" % numero
				resposta = RaizQuadrada(numero)
				
			elif msg[0:13] == "maximodivisor":
				numero = msg[msg.rfind("(")+1:msg.rfind(")")]
				print "MaximoDivisor: '%s'" % numero
				resposta = MaximoDivisor(numero)
				
			print "Resposta:\n'%s'\n" % (resposta)
			skt_cliente.send(str(resposta) + "\n")
		except Exception:
			recebe = 0
			raise
			print "Cliente desconectado\n---"
	skt_cliente.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)	
	skt_cliente.shutdown(2)
	skt_cliente.close()


def Servidor(porta):
	"""
	Funcao que recebe uma porta e estabelece um novo servidor do tipo TCP
	e comeca a receber pedidos de conexoes, cada pedido eh tratado por uma nova
	thread: trataCliente()
	Entradas:
		porta: porta para abrir servidor local
	Saidas: Impressoes na tela
	"""
	skt_servidor = socket.socket(socket.AF_INET, socket.SOCK_STREAM)		# Cria socket TCP
	skt_servidor.bind(('', int(porta)))			# Faz a ligacao dele com a porta passada por parametro
	skt_servidor.listen(5)									# Numero de hand-shakes (pedidos de conexoes simultaneas)
	
	ativo = 1
	recebe = 1
	
	while ativo:
		try:
			(skt_cliente, skt_cliente_endereco) = skt_servidor.accept()
			print "---\nNovo cliente: %s:%s" % (skt_cliente_endereco[0], skt_cliente_endereco[1])
			# Cria uma nova thread para tratar pedido do cliente
			thread.start_new_thread(trataCliente, (skt_cliente, skt_cliente_endereco))
		except KeyboardInterrupt:   #   Trata o CTRL+C
			ativo = 0
		except Exception:
			ativo = 0
			raise
	
	try:
		skt_cliente.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)	
		skt_cliente.shutdown(2)
		skt_cliente.close()
		del skt_cliente
		skt_servidor.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)	
		skt_servidor.shutdown(2)
		skt_servidor.close()
		del skt_servidor
		time.sleep(1)
	except:
		pass
	print "Saindo..."
	sys.exit()


def main(argv):
	servidor = Servidor(argv[1])

if __name__ == "__main__":
	if len(sys.argv) == 2:
		porta = sys.argv[1]
		if porta.isdigit() == True:
			main(sys.argv)
			sys.exit(0)
	print "Uso: %s porta" % sys.argv[0]
